<template>
  <div class="home">
    <h3>room {{ $route.params.name }}</h3>
    <div v-if="!usernameSet">
      <p>Pick an username:</p>
      <input
        v-model="username"
        @keyup.enter="join"
        placeholder="Elon"
        autofocus
      />
      <button @click="join">OK</button>
    </div>
    <div v-else>
      <Chat
        :messages="messages"
      />
      <Prompt
        :roomName="roomName"
        :usersTyping="usersTyping"
      />

      <UserList />
    </div>
  </div>
</template>

<script>
// @ is an alias to /src
import Chat from "@/components/Chat.vue";
import Prompt from "@/components/Prompt.vue";
import UserList from "@/components/UserList.vue";

export default {
  name: "Home",
  data: function() {
    return {
      roomName: this.$route.params.name,
      username: "",
      usernameSet: false,
      messages: [],
      users: [],
      usersTyping: [],
    };
  },
  methods: {
    join: async function() {
      this.usernameSet = true;

      this.getHistory();
      this.$socket.emit("join", {channelName: this.roomName, username: this.username});
    },
    getHistory: async function() {
      console.log("fetching history");
      const res = await fetch(
        `http://localhost:3000/messages/${this.roomName}/getAll`
      );
      this.messages = [...(await res.json()), ...this.messages];

      console.log(this.messages);
    }
  },
  sockets: {
    message: function(message) {
      console.log("message", message);
      this.messages.push(message);
    },
    typing: function({username}) {
      if (!this.usersTyping.includes(username)) this.usersTyping = [...this.usersTyping, username];
    },
    typingStop: function({username}) {
      this.usersTyping = [...this.usersTyping.filter(name => name != username)];
    }
  },
  mounted: function() {
  },
  beforeUnmount: function() {
    this.$socket.emit("leave", this.roomName);
  },
  components: {
    Chat,
    Prompt,
    UserList
  }
};
</script>
